As of February 2015, the latest release of Joomla is version 3.4.0.

New features of Joomla 3.4.0

Improved Front End Module Editing: The way you can edit modules from the front end has improved over earlier versions.

Removal of the Weblinks component: To make the core Joomla installation lighter, they have removed the Weblinks component. If you have upgraded from earlier versions of Joomla 3+, your weblinks component will still be present in the drop down menu under Components. If you have a fresh 3.4.0 installation, there will be no Weblink component shown or installed. If you feel that you need this functionality, they suggest that you install an extension.

Composer Integration: This is for managing external dependencies such as the Joomla Framework and PHPMailer.

Google new reCaptcha: The newest version of Google's reCaptcha is available for use with Joomla 3.4.0, it is supposed to be easier to decipher than previous versions.

UploadShield code: This code works when users are uploading files to a Joomla installation. It helps to detect malicious uploads by looking at their names and file contents.

700+ Bug Fixes: Over 700 known Joomla bugs have been addressed with this latest release.

Issues with the Joomla 3.4.0 Release

Extension installation from the web: With the Joomla 3.4.0 release the ability to upload extensions directly from your Joomla admin interface in Extension Manager is not available. You must resort to downloading the zip file from the provider and uploading this file via Extension Manager. 

Upgrading an existing Joomla installation

Always backup existing site files and database prior to doing an upgrade. do not rely on your hosting service to provide backups.

check to see if the extensions you have installed on your existing site will be compatible with your new version. You may need run upgrades on the extensions. Extensions themselves may have issues and bugs with newer Joomla releases.

Follow the guidelines and instructions provided by Joomla.org for upgrading and existing site.

Be sure that your hosting environment meets the minimum requirements for Joomla 3.4.0 as far as PHP, MySQL and Apache: Technical Requirements

Download Joomla 3.4.0

New Installations

Upgrade from earlier Joomla versions